Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderTechniques/OgreDepthShadowRecieverRenderTechnique.h
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderTechniques/OgreDepthShadowRecieverRenderTechnique.h	(revision 1670)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderTechniques/OgreDepthShadowRecieverRenderTechnique.h	(revision 2180)
@@ -47,4 +47,6 @@
 							String shadowVertexProgram,
 							String shadowFragmentProgram,
+							String WorldViewProjParamName,
+							String WorldParamName,
 							bool setLightViewMatrix,
 							bool setLightViewProjMatrix,
@@ -92,4 +94,7 @@
 	String lightViewParamName;
 	String lightFarPlaneParamName;
+	String WorldViewProjParamName;
+	String WorldParamName;
+												
 };
 
@@ -116,5 +121,6 @@
 	String lightViewParamName;
 	String lightFarPlaneParamName;
-
+	String WorldViewProjParamName;
+	String WorldParamName;
 };
 
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/OgreRenderingRun.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/OgreRenderingRun.cpp	(revision 2174)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/OgreRenderingRun.cpp	(revision 2180)
@@ -173,5 +173,5 @@
 	}
 
-	//sm->_findVisibleObjectsOC(cam, cam->getViewport(), false, true, shadowcastersonly);
+	//sm->_findVisibleObjectsOC(cam, cam->getViewport(), false, false, shadowcastersonly);
 	sm->_findVisibleObjects(cam, shadowcastersonly);
 	
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreDepthShadowMapRenderingRun.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreDepthShadowMapRenderingRun.cpp	(revision 1688)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreDepthShadowMapRenderingRun.cpp	(revision 2180)
@@ -101,5 +101,5 @@
 	}	
 	
-	//rt->writeContentsToFile("shadowmap1.dds");
+	rt->writeContentsToFile("shadowmap1.dds");
 
 	//depthMapTexture->();
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreChildParticlesystemRenderingRun.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreChildParticlesystemRenderingRun.cpp	(revision 1878)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreChildParticlesystemRenderingRun.cpp	(revision 2180)
@@ -125,5 +125,5 @@
 	//filename.append(StringConverter::toString(framecount));
 	filename.append(".bmp");
-	//rt->writeContentsToFile(filename);
+	rt->writeContentsToFile(filename);
 	framecount++;	
 	
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreCubeMapRenderingRun.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreCubeMapRenderingRun.cpp	(revision 2174)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreCubeMapRenderingRun.cpp	(revision 2180)
@@ -118,5 +118,5 @@
 			else
 			{
-				//sm->_findVisibleObjectsOC(cam, rt->getViewport(0), false, true, false);
+				//sm->_findVisibleObjectsOC(cam, rt->getViewport(0), false, false, false);
 				sm->_findVisibleObjects(cam, false);
 				sm->_queueSkiesForRendering(cam);
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderTechniques/OgreDepthShadowRecieverRenderTechnique.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderTechniques/OgreDepthShadowRecieverRenderTechnique.cpp	(revision 1670)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderTechniques/OgreDepthShadowRecieverRenderTechnique.cpp	(revision 2180)
@@ -8,4 +8,6 @@
 												String shadowVertexProgram,
 												String shadowFragmentProgram,
+												String WorldViewProjParamName,
+												String WorldParamName,
 												bool setLightViewMatrix,
 												bool setLightViewProjMatrix,
@@ -30,4 +32,6 @@
 	this->lightViewParamName = lightViewParamName;
 	this->lightFarPlaneParamName = lightFarPlaneParamName;
+	this->WorldParamName = WorldParamName;
+	this->WorldViewProjParamName = WorldViewProjParamName;
 		
 	//insert new passes
@@ -55,7 +59,7 @@
 		
 		GpuProgramParameters* Vparams = newpass->getVertexProgramParameters().getPointer();
-		Vparams->setNamedAutoConstant("worldViewProj",
+		Vparams->setNamedAutoConstant(WorldViewProjParamName,
 									GpuProgramParameters::ACT_WORLDVIEWPROJ_MATRIX);	
-		Vparams->setNamedAutoConstant("world",
+		Vparams->setNamedAutoConstant(WorldParamName,
 									GpuProgramParameters::ACT_WORLD_MATRIX);
 		GpuProgramParameters* Fparams = newpass->getFragmentProgramParameters().getPointer();
@@ -185,4 +189,34 @@
 			f->lightFarPlaneParamName =  vecparams[1];
 	}
+
+	void parseLightProjParamName(String& params, RenderTechniqueFactory* factory)
+	{
+		OgreDepthShadowRecieverRenderTechniqueFactory* f = (OgreDepthShadowRecieverRenderTechniqueFactory*) factory;
+		f->lightViewProjParamName =  params;
+	}
+
+	void parseLightViewParamName(String& params, RenderTechniqueFactory* factory)
+	{
+		OgreDepthShadowRecieverRenderTechniqueFactory* f = (OgreDepthShadowRecieverRenderTechniqueFactory*) factory;
+		f->lightViewParamName =  params;
+	}
+
+	void parseWorldViewProjParamName(String& params, RenderTechniqueFactory* factory)
+	{
+		OgreDepthShadowRecieverRenderTechniqueFactory* f = (OgreDepthShadowRecieverRenderTechniqueFactory*) factory;
+		f->WorldViewProjParamName =  params;
+	}
+
+	void parseWorldParamName(String& params, RenderTechniqueFactory* factory)
+	{
+		OgreDepthShadowRecieverRenderTechniqueFactory* f = (OgreDepthShadowRecieverRenderTechniqueFactory*) factory;
+		f->WorldParamName =  params;
+	}
+
+	void parseLightFarPlaneParamName(String& params, RenderTechniqueFactory* factory)
+	{
+		OgreDepthShadowRecieverRenderTechniqueFactory* f = (OgreDepthShadowRecieverRenderTechniqueFactory*) factory;
+		f->lightFarPlaneParamName =  params;
+	}
 }
 
@@ -199,4 +233,9 @@
 	this->attributeParsers.insert(AttribParserList::value_type("set_light_view", (ILLUM_ATTRIBUTE_PARSER) parseSetLightView));
 	this->attributeParsers.insert(AttribParserList::value_type("set_light_farplane", (ILLUM_ATTRIBUTE_PARSER) parseSetLightFarPlane));
+	this->attributeParsers.insert(AttribParserList::value_type("light_viewproj_param_name", (ILLUM_ATTRIBUTE_PARSER) parseLightProjParamName));
+	this->attributeParsers.insert(AttribParserList::value_type("light_view_param_name", (ILLUM_ATTRIBUTE_PARSER) parseLightViewParamName));
+	this->attributeParsers.insert(AttribParserList::value_type("world_view_proj_param_name", (ILLUM_ATTRIBUTE_PARSER) parseWorldViewProjParamName));
+	this->attributeParsers.insert(AttribParserList::value_type("world_param_name", (ILLUM_ATTRIBUTE_PARSER) parseWorldParamName));
+	this->attributeParsers.insert(AttribParserList::value_type("light_farplane_param_name", (ILLUM_ATTRIBUTE_PARSER) parseLightFarPlaneParamName));
 }
 
@@ -209,12 +248,14 @@
 	//reset parameters
 	maxlights = 1;
-	shadowVertexProgram = "GameTools/ShadowMap/ShadowVS";
-	shadowFragmentProgram = "GameTools/ShadowMap/ShadowPS";
+	shadowVertexProgram = "GTP/Basic/LightCPos_VS";
+	shadowFragmentProgram = "GTP/Basic/SM/Dist_PS";
 	setLightViewMatrix = false;
 	setLightViewProjMatrix = true;
 	setLightProjFarPlane = false;
-	lightViewProjParamName = "lightViewProj";
-	lightViewParamName = "lightView";
+	lightViewProjParamName = "LightViewProj";
+	lightViewParamName = "LightView";
 	lightFarPlaneParamName = "lightFarPlane";
+	WorldViewProjParamName = "WorldViewProj";
+	WorldParamName = "World";
 
 	parseParams(params);
@@ -224,4 +265,6 @@
 												shadowVertexProgram,
 												shadowFragmentProgram,
+												WorldViewProjParamName,
+												WorldParamName,
 												setLightViewMatrix ,
 												setLightViewProjMatrix,
Index: /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/OgreIlluminationManager.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/OgreIlluminationManager.cpp	(revision 2174)
+++ /GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/OgreIlluminationManager.cpp	(revision 2180)
@@ -401,5 +401,5 @@
 		}
 		
-		//sceneManager->_findVisibleObjectsOC(rt->getViewport(i)->getCamera(), rt->getViewport(i), false, true, false);
+		//sceneManager->_findVisibleObjectsOC(rt->getViewport(i)->getCamera(), rt->getViewport(i), false, false, false);
 		sceneManager->_findVisibleObjects(rt->getViewport(i)->getCamera(), false);
 		