Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/OgreIlluminationManager.h
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/OgreIlluminationManager.h	(revision 2185)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/OgreIlluminationManager.h	(revision 2189)
@@ -84,4 +84,5 @@
 	unsigned int focusingMapSize;
 	unsigned int shadowMapSize;
+	float areaLightRadius;
 	bool useLISPSM;
 	bool useVSM;
@@ -347,8 +348,22 @@
 		this->pathMapEntryPoints.push_back(p);
 	}
+	std::vector<PathMapEntryPoint>& getPathMapEntryPoints()
+	{
+		return pathMapEntryPoints;
+	}
 	void addPathMapClusterLength(unsigned int l)
 	{
 		this->pathMapClusterLengths.push_back(l);
 	}
+	unsigned int getPathMapClusterLengthsSize()
+	{
+		return this->pathMapClusterLengths.size();
+	}
+	unsigned int getPathMapClusterLength(unsigned int index)
+	{
+		return pathMapClusterLengths.at(index);
+	}
+	float getAreaLightRadius(){return areaLightRadius;}
+	void setAreaLigtRadius(float radius){areaLightRadius = radius;}
 };
 
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgrePMWeightComputeRenderingRun.h
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgrePMWeightComputeRenderingRun.h	(revision 2189)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgrePMWeightComputeRenderingRun.h	(revision 2189)
@@ -0,0 +1,62 @@
+#pragma once
+
+//disable inheritance warning caused by multiple inheritance
+#if _WIN32
+#if _MSC_VER
+#pragma warning(disable: 4250)
+#endif
+#endif
+
+#include "OgreRenderingRun.h"
+#include "OgreSharedRuns.h"
+
+
+/**
+	@brief ColorCubeMapRenderingRun used in an OGRE environment.
+*/
+class OgrePMWeightComputeRenderingRun : public OgreRenderingRun									
+{	
+public:
+
+	/**
+		@brief Constructor.
+
+		
+	*/	
+	OgrePMWeightComputeRenderingRun(String name, String LightName);
+	/**
+		@brief returns the name of the camera depth texture
+	*/
+	String getPMWeightTetureName(){return name;}
+	float* getWeights(){return weights;}
+	
+protected:
+	/**
+		@brief pointer to the player's viewport	
+	*/
+	Matrix4 lightMatrix;
+	Matrix4 lightViewMatrix;
+	/**
+		@brief the name of the weight texture that was created by this run
+	*/
+	String name;
+	/**
+		@brief a pointer to the scene depth texture that was created by this run
+	*/
+	Texture* weightTexture;
+	
+	Light* light;
+
+	float* weights;
+
+	//inherited
+	void updateFrame(unsigned long frameNum);	
+	
+	inline void createWeightMap();
+
+	bool needUpdate(unsigned long frameNum )
+	{
+		return true;
+	}
+
+};
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgrePMEntryPointMapRenderingRun.h
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgrePMEntryPointMapRenderingRun.h	(revision 2189)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgrePMEntryPointMapRenderingRun.h	(revision 2189)
@@ -0,0 +1,52 @@
+#pragma once
+
+//disable inheritance warning caused by multiple inheritance
+#if _WIN32
+#if _MSC_VER
+#pragma warning(disable: 4250)
+#endif
+#endif
+
+#include "OgreRenderingRun.h"
+#include "OgreSharedRuns.h"
+
+
+/**
+	@brief ColorCubeMapRenderingRun used in an OGRE environment.
+*/
+class OgrePMEntryPointMapRenderingRun : public OgreRenderingRun									
+{	
+public:
+
+	/**
+		@brief Constructor.
+
+		
+	*/	
+	OgrePMEntryPointMapRenderingRun(String name);
+	/**
+		@brief returns the name of the camera depth texture
+	*/
+	String getEntryPointTextureName(){return name;}
+	
+protected:
+	/**
+		@brief the name of the entry point texture that was created by this run
+	*/
+	String name;
+	/**
+		@brief a pointer to the scene depth texture that was created by this run
+	*/
+	Texture* entryPointTexture;
+	
+	//inherited
+	void updateFrame(unsigned long frameNum);	
+	
+	inline void createEntryPointMap();
+
+	bool needUpdate(unsigned long frameNum )
+	{
+		return true;
+	}
+
+};
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderTechniques/OgrePathMapRenderTechnique.h
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderTechniques/OgrePathMapRenderTechnique.h	(revision 2185)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderTechniques/OgrePathMapRenderTechnique.h	(revision 2189)
@@ -55,5 +55,5 @@
 	
 protected:	
-	
+	Pass* pathMapPass;
 	PathMapClusters* clusters;	
 };
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.7.10.vcproj
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.7.10.vcproj	(revision 2185)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/scripts/OgreIllumModule.7.10.vcproj	(revision 2189)
@@ -205,4 +205,10 @@
 				</File>
 				<File
+					RelativePath="..\src\RenderingRuns\OgrePMEntryPointMapRenderingRun.cpp">
+				</File>
+				<File
+					RelativePath="..\src\RenderingRuns\OgrePMWeightComputeRenderingRun.cpp">
+				</File>
+				<File
 					RelativePath="..\src\RenderingRuns\OgreReducedCubeMapRenderingRun.cpp">
 				</File>
@@ -305,4 +311,10 @@
 				</File>
 				<File
+					RelativePath="..\include\RenderingRuns\OgrePMEntryPointMapRenderingRun.h">
+				</File>
+				<File
+					RelativePath="..\include\RenderingRuns\OgrePMWeightComputeRenderingRun.h">
+				</File>
+				<File
 					RelativePath="..\include\RenderingRuns\OgreReducedCubeMapRenderingRun.h">
 				</File>
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMWeightComputeRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMWeightComputeRenderingRun.cpp	(revision 2189)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMWeightComputeRenderingRun.cpp	(revision 2189)
@@ -0,0 +1,109 @@
+#include "OgrePMWeightComputeRenderingRun.h"
+#include "OgreIlluminationManager.h"
+#include "OgrePMEntryPointMapRenderingRun.h"
+
+OgrePMWeightComputeRenderingRun::OgrePMWeightComputeRenderingRun(String name, String LightName)
+														   : OgreRenderingRun(1, 1)
+														   , RenderingRun(1, 1)
+{
+	this->name = name;
+	weights = 0;
+	
+	this->light = Root::getSingleton()._getCurrentSceneManager()->getLight(LightName);
+	createWeightMap();
+
+	OgreIlluminationManager::getSingleton().createGlobalRun(ILLUMRUN_PM_ENTRYPOINTMAP);
+}
+
+void OgrePMWeightComputeRenderingRun::createWeightMap()
+{
+	
+	unsigned int entryPointCnt = OgreIlluminationManager::getSingleton().getPathMapEntryPoints().size();
+	int width = entryPointCnt / 4096;
+	int height = 4096;
+	TexturePtr texPtr = Ogre::TextureManager::getSingleton().createManual(name, 
+																		"default",
+																		TEX_TYPE_2D,
+																		width,
+																		height,
+																		0,
+																		0,
+																		PF_FLOAT32_R,
+																		TU_RENDERTARGET);
+	 weightTexture = texPtr.getPointer();
+	 //add viewport to rendertarget
+	 HardwarePixelBuffer* hpb = (weightTexture->getBuffer()).getPointer();
+	 RenderTarget* rt = hpb->getRenderTarget();
+	 Camera* wc = Root::getSingleton()._getCurrentSceneManager()->createCamera(name + "_CAMERA"); 
+	 Viewport* v = rt->addViewport(wc);
+	 v->setOverlaysEnabled(false);
+	 rt->setAutoUpdated(false);
+}
+
+
+
+void OgrePMWeightComputeRenderingRun::updateFrame(unsigned long frameNum)
+{
+	switch(light->getType())
+	{
+		case Light::LT_SPOTLIGHT:
+
+			MaterialPtr mat = MaterialManager::getSingleton().getByName("GTP/PathMap_ComputeWeights");
+
+			GpuProgramParameters* Fparams = mat->getTechnique(0)->getPass(0)->getFragmentProgramParameters().getPointer();
+			
+			Vector3 lightPos = light->getPosition();
+			Vector3 lightDir = light->getDirection();
+		//	Radian lightAngle = light->getSpotlightOuterAngle();
+			unsigned int entryPointCnt = OgreIlluminationManager::getSingleton().getPathMapEntryPoints().size();
+			int col = entryPointCnt / 4096; 
+
+			//Fparams->setNamedConstant("lightTransform", lightMatrix);
+			Fparams->setNamedConstant("nRadionColumns", col);
+			Fparams->setNamedConstant("lightPos", lightPos);
+			Fparams->setNamedConstant("lightDir", lightDir);
+
+			OgrePMEntryPointMapRenderingRun* PMEPrun = (OgrePMEntryPointMapRenderingRun*)
+					OgreIlluminationManager::getSingleton().getGlobalRun(ILLUMRUN_PM_ENTRYPOINTMAP)->asOgreRenderingRun();
+			mat->getTechnique(0)->getPass(0)->getTextureUnitState(0)->setTextureName(
+						PMEPrun->getEntryPointTextureName());
+				
+			RenderTarget* rt = weightTexture->getBuffer().getPointer()->getRenderTarget();
+			renderFullscreenQuad(mat->getName(), rt);
+
+			//rt->writeContentsToFile("focusingmap.dds");
+		
+		
+			break;		
+	}
+
+	unsigned int clustercount = OgreIlluminationManager::getSingleton().getPathMapClusterLengthsSize();
+	if(weights == 0)
+		weights = new float[clustercount];
+	
+	unsigned int entryPointCnt = OgreIlluminationManager::getSingleton().getPathMapEntryPoints().size();
+	int width = entryPointCnt / 4096;
+	int height = 4096;
+	unsigned int buffersize = width * height;
+	float* allEntryWeights = new float[buffersize];
+	PixelBox lockBox(width, height, 1, PF_FLOAT32_R, allEntryWeights);
+	weightTexture->getBuffer()->blitToMemory(lockBox);	
+
+	int iRadion = 0;
+	for(int iCluster=0; iCluster < clustercount; iCluster++)
+	{
+		weights[iCluster] = 0.0;
+		for(int clusterSummer=0;
+			clusterSummer < OgreIlluminationManager::getSingleton().getPathMapClusterLength(iCluster);
+			clusterSummer++, iRadion++)
+		{
+			weights[iCluster] += allEntryWeights[iRadion];			
+		}
+		if(weights[iCluster] <= 0)
+			weights[iCluster] /= OgreIlluminationManager::getSingleton().getPathMapClusterLength(iCluster); //(double)clusterLenghts[iCluster];
+		else
+			weights[iCluster] = 0.0f;		
+	}
+}
+
+
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMEntryPointMapRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMEntryPointMapRenderingRun.cpp	(revision 2189)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgrePMEntryPointMapRenderingRun.cpp	(revision 2189)
@@ -0,0 +1,57 @@
+#include "OgrePMEntryPointMapRenderingRun.h"
+#include "OgreIlluminationManager.h"
+
+OgrePMEntryPointMapRenderingRun::OgrePMEntryPointMapRenderingRun(String name)
+														   : OgreRenderingRun(1, 1)
+														   , RenderingRun(1, 1)
+{
+	this->name = name;
+	
+	createEntryPointMap();	
+}
+
+void OgrePMEntryPointMapRenderingRun::createEntryPointMap()
+{
+	unsigned int entryPointCnt = OgreIlluminationManager::getSingleton().getPathMapEntryPoints().size();
+	int width = entryPointCnt / 4096 * 2;
+	int height = 4096;
+	TexturePtr texPtr = Ogre::TextureManager::getSingleton().createManual(name, 
+																		"default",
+																		TEX_TYPE_2D,
+																		width,
+																		height,
+																		0,
+																		0,
+																		PF_FLOAT32_RGBA,
+																		TU_DEFAULT);
+	entryPointTexture = texPtr.getPointer();
+	
+	struct TMR
+	{
+		float pos[4];
+		float dir[4];
+	};
+	TMR* tm = new TMR[entryPointCnt];
+	for(int i=0; i<entryPointCnt; i++)
+	{
+		PathMapEntryPoint* EP = &OgreIlluminationManager::getSingleton().getPathMapEntryPoints().at(i);
+		tm[i].pos[0] = EP->position.x;
+		tm[i].pos[1] = EP->position.y;
+		tm[i].pos[2] = EP->position.z;
+		tm[i].pos[3] = 1.0;
+		tm[i].dir[0] = EP->normal.x;
+		tm[i].dir[1] = EP->normal.y;
+		tm[i].dir[2] = EP->normal.z;
+		tm[i].dir[3] = 1.0;
+	}	
+
+	PixelBox lockBox(width, height, 1, PF_FLOAT32_RGBA, tm);
+	entryPointTexture->getBuffer()->blitFromMemory(lockBox);
+}
+
+void OgrePMEntryPointMapRenderingRun::updateFrame(unsigned long frameNum)
+{	
+	
+}
+
+
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreDepthShadowMapRenderingRun.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreDepthShadowMapRenderingRun.cpp	(revision 2182)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderingRuns/OgreDepthShadowMapRenderingRun.cpp	(revision 2189)
@@ -315,5 +315,5 @@
 				depthMapCamera->setFOVy(lightangle);
 				depthMapCamera->setAspectRatio(1);
-				depthMapCamera->setNearClipDistance(0.1);
+				depthMapCamera->setNearClipDistance(OgreIlluminationManager::getSingleton().getAreaLightRadius());
 				depthMapCamera->setFarClipDistance(1.0);
 			}
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderTechniques/OgreDepthShadowRecieverRenderTechnique.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderTechniques/OgreDepthShadowRecieverRenderTechnique.cpp	(revision 2180)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderTechniques/OgreDepthShadowRecieverRenderTechnique.cpp	(revision 2189)
@@ -66,5 +66,5 @@
 		
 		TextureUnitState* st = newpass->createTextureUnitState();		
-		st->setTextureFiltering(TFO_ANISOTROPIC);
+		st->setTextureFiltering(TFO_NONE);
 		st->setTextureAddressingMode(TextureUnitState::TAM_BORDER);
 		st->setTextureBorderColour(ColourValue::White);
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderTechniques/OgrePathMapRenderTechnique.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderTechniques/OgrePathMapRenderTechnique.cpp	(revision 2185)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/RenderTechniques/OgrePathMapRenderTechnique.cpp	(revision 2189)
@@ -2,4 +2,6 @@
 #include "OgreTechniqueGroup.h"
 #include "OgreIlluminationManager.h"
+#include "OgrePMWeightComputeRenderingRun.h"
+
 
 
@@ -10,5 +12,5 @@
 							:RenderTechnique( parentRenderable, parentTechniqueGroup),
 							OgreRenderTechnique(pass, parentRenderable, parentTechniqueGroup)
-{		
+{	
 	this->clusters = OgreIlluminationManager::getSingleton().getPathMapClusters(parentRenderable->getName());
 	
@@ -26,5 +28,5 @@
 	}
 	
-	Pass* newpass = techn->createPass();
+	Pass* newpass = pathMapPass = techn->createPass();
 	
 	newpass->setVertexProgram("GTP/PathMap_VS");
@@ -46,7 +48,7 @@
 
 	float halfPixel[2] = {0.5 / prmxres, 0.5 / prmyres};
-	Fparams->setNamedConstant("prmAtlasTiles",prmnt,2);
-    Fparams->setNamedConstant("atlasHalfPixel", halfPixel, 2);
-			
+	Vector4 pathMapParameters(prmnt[0],prmnt[1],halfPixel[0],halfPixel[1]);
+	Fparams->setNamedConstant("prmAtlasTilesHalfPixel",pathMapParameters);
+    		
 	TextureUnitState* st = newpass->createTextureUnitState();		
 	st->setTextureFiltering(TFO_BILINEAR);
@@ -54,9 +56,11 @@
 	st->setTextureBorderColour(ColourValue::Blue);
 	st->setTextureName(clusters->pathMapTextureFilename);
-
+	
 	//newpass->setSceneBlending(SBT_MODULATE);
 	newpass->setSceneBlending(SBF_ONE, SBF_ZERO);
+	newpass->setDepthBias(1);
+	
 
-	newpass->setDepthBias(1);
+	
 }
 
@@ -68,5 +72,27 @@
 void OgrePathMapRenderTechnique::update(unsigned long frameNum)
 {	
-	//TODO set weights
+	LightList lights;
+	SceneManager* sm = Root::getSingleton()._getCurrentSceneManager();
+	sm->_populateLightList(Vector3(0,0,0), 1000, lights); //TODO
+//TODO set weights
+	PathMapClusters* clusters = OgreIlluminationManager::getSingleton().getPathMapClusters(parentOgreRenderable->getName());
+	float *actualWeights = new float[clusters->count];//TODO = 0
+	for(int i = 0 ; i < 1; i++)
+	{
+		String lightName = lights.at(0)->getName();
+		OgreIlluminationManager::getSingleton().createPerLightRun(lightName, ILLUMRUN_PM_WEIGHTMAP);
+		OgreIlluminationManager::getSingleton().updatePerLightRun(lightName, ILLUMRUN_PM_WEIGHTMAP, frameNum);
+		OgrePMWeightComputeRenderingRun* PMWeightRun = (OgrePMWeightComputeRenderingRun*)
+			OgreIlluminationManager::getSingleton().getPerLightRun(lightName, ILLUMRUN_PM_WEIGHTMAP)->asOgreRenderingRun();
+
+		float* weights = PMWeightRun->getWeights();
+		
+		for(int j = 0; j< clusters->count; j++)
+			actualWeights[j] = weights[clusters->clusters[j]];
+				
+	}
+
+	GpuProgramParameters* Fparams = pathMapPass->getFragmentProgramParameters().getPointer();
+	Fparams->setNamedConstant("weights", actualWeights, clusters->count);
 }
 
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/OgreIlluminationManager.cpp
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/OgreIlluminationManager.cpp	(revision 2185)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/src/OgreIlluminationManager.cpp	(revision 2189)
@@ -3,4 +3,6 @@
 #include "OgreBillboardParticleRenderer.h"
 #include "SpriteParticleRenderer.h"
+#include "OgrePMEntryPointMapRenderingRun.h"
+#include "OgrePMWeightComputeRenderingRun.h"
 
 OgreIlluminationManager* OgreIlluminationManager::instance = NULL;
@@ -85,5 +87,6 @@
 	blurSM = false;
 	focusingSM = true;
-	shadowMapMaterialName = "GameTools/ShadowMapDepth";
+	shadowMapMaterialName = "GTP/Basic/Distance_NormalizedCCW";
+	areaLightRadius = 0.1;
 
 	for(int i = 0; i < RUN_TYPE_COUNT; i++)
@@ -193,5 +196,5 @@
 		OgreRenderable* rend = 0;	
 		OgreTechniqueGroup* group = 0;
-	
+
 		for(unsigned int t = 0 ; t < mat->getNumTechniques() ; t++)
 		{
@@ -203,11 +206,6 @@
 
 				std::vector<IllumTechniqueParams*>& techniques = pass->getIllumTechniques();
-				std::vector<IllumTechniqueParams*>::iterator i = techniques.begin(); 
-				std::vector<IllumTechniqueParams*>::iterator iend = techniques.end();
-				
-				while( i != iend)
+				if( techniques.size() > 0)
 				{
-					IllumTechniqueParams* params = *i;
-					
 					if(rend == 0)
 					{
@@ -226,5 +224,29 @@
 						sharedruns->updateBounds();
 					}
-					
+					String newMaterialName = mat->getName() + rend->getName() + "_clone";
+					Material* newMat = mat->clone(newMaterialName).getPointer();
+					mat = newMat;
+					rend->setMaterialName(newMaterialName);
+					break;
+				}
+			}
+		}
+
+	
+		for(unsigned int t = 0 ; t < mat->getNumTechniques() ; t++)
+		{
+			Technique* tech = mat->getTechnique(t);
+
+			for(unsigned int p = 0; p< tech->getNumPasses(); p++)
+			{
+				Pass* pass = tech->getPass(p);
+
+				std::vector<IllumTechniqueParams*>& techniques = pass->getIllumTechniques();
+				std::vector<IllumTechniqueParams*>::iterator i = techniques.begin(); 
+				std::vector<IllumTechniqueParams*>::iterator iend = techniques.end();
+				
+				while( i != iend)
+				{
+					IllumTechniqueParams* params = *i;
 					createTechnique(params, pass, rend, sharedruns); 
 
@@ -545,4 +567,12 @@
 		}
 		break;
+		case ILLUMRUN_PM_ENTRYPOINTMAP:
+		if(globalSharedRuns.getRun(ILLUMRUN_PM_ENTRYPOINTMAP) == 0)
+		{
+			OgrePMEntryPointMapRenderingRun* run  = new OgrePMEntryPointMapRenderingRun(
+				"PM_ENTRYPOINT_MAP");
+			globalSharedRuns.addRun(ILLUMRUN_PM_ENTRYPOINTMAP, run);			
+		}
+		break;
 	}
 }
@@ -614,4 +644,14 @@
 		}		
 		break;
+		case ILLUMRUN_PM_WEIGHTMAP:
+		if(runs->getRun(ILLUMRUN_PM_WEIGHTMAP) == 0)
+		{
+			SceneManager* sm = Root::getSingleton()._getCurrentSceneManager();
+			OgrePMWeightComputeRenderingRun* run  = new OgrePMWeightComputeRenderingRun(				
+				lightName + "PM_WEIGHT_MAP",
+				lightName);
+			runs->addRun(ILLUMRUN_PM_WEIGHTMAP, run);			
+		}		
+		break;
 	}	
 }
Index: GTP/trunk/Lib/Illum/IllumModule/IllumModule/include/SharedRuns.h
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/IllumModule/include/SharedRuns.h	(revision 1722)
+++ GTP/trunk/Lib/Illum/IllumModule/IllumModule/include/SharedRuns.h	(revision 2189)
@@ -37,5 +37,7 @@
 	ILLUMRUN_FOCUSING_MAP,
 	ILLUMRUN_LIGHTVOLUME_MAP,
-	ILLUMRUN_PHASE_TEXTURE
+	ILLUMRUN_PHASE_TEXTURE,
+	ILLUMRUN_PM_ENTRYPOINTMAP,
+	ILLUMRUN_PM_WEIGHTMAP
 };
 